

extern "C"
{
 void TIM2_IRQHandler()
 {
  static enum MDE {power_3, power_2, power_1, full_power, off}w_mode = full_power;

  u32 tmp    = TIM2->SR;
  TIM2->SR   = 0;

  //      
  if(!(tmp & TIM_SR_CC4IF))
  {
   static u32 a_cnt;
   static u32 b_cnt;

   //     / 
   if(TIM2->CCER == TIM_CCER_CC1E)
   {
    TIM2->CCER = TIM_CCER_CC1E|TIM_CCER_CC1P; // 

    GPIOA->BSRR = 1<<5;
   }
   else
   {
    TIM2->CCER = TIM_CCER_CC1E;               // 

    GPIOA->BRR = 1<<5;
   }

   //
   {
    if(!b_cnt)
    {
     switch(w_mode)
     {
      case full_power:
      {
       a_cnt = 2;
       b_cnt = 0;
      }break;

      case power_3:
      {
       a_cnt = 3;
       b_cnt = 2;
      }break;

      case power_2:
      {
       a_cnt = 2;
       b_cnt = 2;
      }break;

      case power_1:
      {
       a_cnt = 1;
       b_cnt = 2;
      }break;

      case off:
      {
       a_cnt = 0;
       b_cnt = 2;
      }break;
     }
    }

    if(a_cnt)
    {
     a_cnt--;
     TIM1->CR1 = TIM_CR1_OPM|TIM_CR1_CEN;
    }
    else if(b_cnt) b_cnt--;
   }
  }

  //  
  {
   static bool btn_trg;
   static bool b_set_trg;

   btn_scan();

   if(btn[0]==rls)
   {
    btn_trg = 0;

    if(b_set_trg)
    {
     b_set_trg = 0;

     beep();

     // 
     if(w_mode < full_power)       w_mode = MDE(w_mode +1);
     else if(w_mode == full_power) w_mode = power_3;
    }
   }
   else if (btn[0]==prs)
   {
    b_set_trg = 1;
   }
   else
   {
    b_set_trg = 0;

    if(!btn_trg)
    {
     btn_trg = 1;

     if(w_mode != off) w_mode = off;
     else w_mode = full_power;
    }
   }
  }

  beep_processing();
 }
//-----------------------------------

 void SysTick_Handler()
 {
  static bool trg;

  if(trg)
  {
   trg = 0;

  }
  else
  {
   trg = 1;


  }

 }

//-----------------------------------

 void HardFault_Handler()
 {

  NVIC_SystemReset();
 }

 void NMI_Handler()
 {

  NVIC_SystemReset();
 }

 void Default_Handler()
 {

  while(1)__no_operation();
 }
}



//   Reset_Handler                  ; Reset Handler
//
//   NMI_Handler                    ; NMI Handler
//   HardFault_Handler              ; Hard Fault Handler
//   PendSV_Handler                 ; PendSV Handler
//   SysTick_Handler                ; SysTick Handler
//
//  ; External Interrupts
//   WWDG_IRQHandler                ; Window Watchdog
//   PVD_IRQHandler                 ; PVD through EXTI Line detect
//   RTC_IRQHandler                 ; RTC through EXTI Line
//   FLASH_IRQHandler               ; FLASH
//   RCC_IRQHandler                 ; RCC
//   EXTI0_1_IRQHandler             ; EXTI Line 0 and 1
//   EXTI2_3_IRQHandler             ; EXTI Line 2 and 3
//   EXTI4_MDEV_IRQHandler            ; EXTI Line 4 to MDEV
//   TS_IRQHandler                  ; TS
//   DMA1_Channel1_IRQHandler       ; DMA1 Channel 1
//   DMA1_Channel2_3_IRQHandler     ; DMA1 Channel 2 and Channel 3
//   DMA1_Channel4_5_IRQHandler     ; DMA1 Channel 4 and Channel 5
//   ADC1_COMP_IRQHandler           ; ADC1, COMP1 and COMP2
//   TIM1_BRK_UP_TRG_COM_IRQHandler ; TIM1 Break, Update, Trigger and Commutation
//   TIM1_CC_IRQHandler             ; TIM1 Capture Compare
//   TIM2_IRQHandler                ; TIM2
//   TIM3_IRQHandler                ; TIM3
//   TIM6_DAC_IRQHandler            ; TIM6 and DAC
//   0                              ; Reserved
//   TIM14_IRQHandler               ; TIM14
//   TIMMDEV_IRQHandler               ; TIMMDEV
//   TIM16_IRQHandler               ; TIM16
//   TIM17_IRQHandler               ; TIM17
//   I2C1_IRQHandler                ; I2C1
//   I2C2_IRQHandler                ; I2C2
//   SPI1_IRQHandler                ; SPI1
//   SPI2_IRQHandler                ; SPI2
//   USART1_IRQHandler              ; USART1
//   USART2_IRQHandler              ; USART2
//   0                              ; Reserved
//   CEC_IRQHandler                 ; CEC
//   0                              ; Reserved

